routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use Illuminate\Support\Facades\Route;

// route admin login logout
Route::group(['prefix'=>'admin','namespace'=>'Admin'],function (){
    Route::get('/login', 'LoginController@showLoginForm')->name('admin.login');
    Route::post('/login', 'LoginController@login')->name('admin.login');
    Route::get('/logout', 'LoginController@logOut')->name('admin.logout');

    //shjhghhjhj
});
// route admin quản lý user
Route::group(['prefix'=>'admin/user','namespace'=>'Admin', 'middleware'=>['admin']],function (){
    // Show List Admin
    Route::get('/list', 'UserController@showList')->name('list.user');
    Route::get('/get-list','UserController@getAll')->name('get.data.user');

    //Add
    Route::get('/add', 'UserController@getAddUser')->name('add.user');
    Route::post('/add', 'UserController@postAddUser');

    //Delete
    Route::get('/delete/{id}', 'UserController@getDeleteUser')->name('delete.user');

    //Edit
    Route::get('/edit/', 'UserController@getEditUser')->name('edit.user');

    Route::post('/edit-user/{id}', 'UserController@postEditUser')->name('post.edit.user');

});
// route admin
Route::group(['prefix'=>'admin', 'namespace'=>'Admin', 'middleware'=>['admin']],function(){
    Route::get('/','AdminController@home')->name('admin.home');
    Route::resource('roles','RoleController');
    Route::resource('users','UserController');
    Route::get('show-role', 'RoleController@showRole')->name('show.role');

    //Category
    Route::group(['prefix'=>'category'],function(){

        //Add
        Route::get('/', 'CategoryController@formAdd')->name('category.add');
        Route::post('/', 'CategoryController@submitAdd')->name('add.category');

        //Delete
        Route::get('/delete/{id}', 'CategoryController@delete')->name('category.delete');

        //Edit
        Route::get('/edit/{id}', 'CategoryController@formEdit')->name('category.edit');
        Route::post('/edit/{id}', 'CategoryController@submitEdit');

    });

    //Attribute
    Route::group(['prefix'=>'attribute'],function(){
        //Show
        Route::get('/', 'AttributeController@getAll')->name('attribute.list');

        //Add
        Route::get('/add', 'AttributeController@formAdd')->name('attribute.add');
        Route::post('/add', 'AttributeController@submitAdd');

        //Delete
        Route::get('/delete/{id}', 'AttributeController@delete')->name('attribute.delete');

        //Edit
        Route::get('/edit/{id}', 'AttributeController@formEdit')->name('attribute.edit');
        Route::post('/edit/{id}', 'AttributeController@submitEdit');

    });

    //Value
    Route::group(['prefix'=>'value'],function(){
        Route::get('/delete/{id}', 'ValueController@delete')->name('value.delete');
    });

    //Product
    Route::resource('product', 'ProductController');
    // get attribute value product
    Route::get('get-att-value', 'ProductController@getAttValue')->name('get.att');
    //get child category
    Route::get('get-cate-child', 'ProductController@getChildCategory')->name('get.child.cate');
    //datatable product
    Route::get('dt-product', 'ProductController@anyDatatable')->name('dt.product');
    Route::get('list-product', 'ProductController@listProduct')->name('list.product');
    //vendor product
    Route::get('dt-vendor-product', 'ProductController@anyDataTableProductVendor')->name('dt.vendor.product');
    Route::get('list-vendor-product', 'ProductController@getListProductVendor')->name('list.vendor.product');
    Route::get('vendor/product/{productId}', 'ProductController@editProductVendor')->name('edit.vendor.product');
    Route::get('confirm-product-vendor', 'ProductController@confirmProductVendor')->name('confirm.product.vendor');
    Route::get('show-admin-confirm-product', 'ProductController@getAdminConfirmProduct')->name('admin.confirm.product.vendor');

    Route::post('deny-confirm-product', 'ProductController@denyConfirmProduct')->name('deny.confirm.product');
    Route::get('revert-status-product', 'ProductController@revertStatusProduct')->name('revert.status.product');

    // get detail cate
    Route::get('detail-cate', 'CategoryController@detailCategory')->name('detail.cate');
    Route::post('update-cate', 'CategoryController@updateCategory')->name('category.update');
    //ajax line cate
    Route::get('change-line-cate/{cateId}', 'CategoryController@changeLineCate')->name('line.cate');

    Route::get('get-att-product', 'ProductController@getAttributeValueProduct')->name('get.att.product');
    Route::get('update-att-product', 'ProductController@updateAttProduct')->name('update.att.product');

    Route::get('edit-image-product/{productId}', 'ProductController@editImageProduct')->name('edit.image.product');
    Route::post('edit-image-productPost', 'ProductController@posteditImageProduct')->name('POSTedit.image.product');
//    ajax show image product
    Route::get('get-detail-image', 'ProductController@getDetailImageProduct')->name('get.detail.image');
    Route::post('update-image-product', 'ProductController@updateImageProduct')->name('update.image.product');
    Route::get('update-image-product/{imageId}', 'ProductController@deleteImageProduct')->name('delete.image.product');

    //test tab
    Route::get('add-configurable-product','ProductController@tabAddProduct')->name('product.add.exProduct');
    Route::post('add-product','ProductController@addProductTab')->name('product.tab.add');
    Route::post('add-subproduct','ProductController@addSubProductTab')->name('product.tab.addSubProduct');
    // ajax addSubProductToTable
    Route::get('add-subproduct-table','ProductController@addSubProductToTable')->name('product.ajax.addSubProduct');
    Route::get('clear-subproduct-table','ProductController@clearSubProductFromTable')->name('product.ajax.clearSubProduct');
    Route::get('add-simple-product','ProductController@tabAddSimpleProduct')->name('product.add.SimpleProduct');
    Route::post('add-simple-product','ProductController@addSimpleProductTab')->name('product.tab.add.SimpleProduct');
    //end tab
    //test image upload
    Route::get('add-image-product',function (){
        return view('admin.product.tab.add.image');
    });
    Route::post('add-images-product/','ProductController@addThumbnailProduct');
    //end image upload
    // update sub product
    Route::post('update-sub-product/','ProductController@updateSubProduct')->name('update.subproduct');
    // delete sub product
    Route::get('delete-sub-product/{productId}','ProductController@deleteSubProduct')->name('delete.subproduct');
    // add new product Option
    //Route::get('add-product-option','ProductController@addProductOption')->name('add.product.option');
    //Slider
    Route::group(['prefix'=>'slider'], function(){
        Route::get('/', 'SliderController@getAll')->name('slider.list');
        Route::post('/', 'SliderController@submitAdd')->name('slider.add');
        Route::get('delete/{id}', 'SliderController@delete')->name('slider.delete');
    });

    //Info Contact
    Route::group(['prefix'=>'info'], function(){
        Route::get('/', 'InfoController@show')->name('info.show');
        Route::post('/edit', 'InfoController@edit')->name('info.edit');
        Route::post('/store', 'InfoController@store')->name('info.store');
    });
	//Order
	Route::group(['prefix' => 'order'], function(){
		Route::get('update/{id}', 'OrderController@updateStatus')->name('order.update.status');
		Route::get('updateRevert/{id}', 'OrderController@revertUpdate')->name('order.revert.status');
		route::get('deleteOrder/{id}','OrderController@deleteOrder')->name('order.delete');
		// Danh sách order Slider
        Route::get('list_order','OrderController@listorder')->name('order.list');
        Route::get('list_order_finish','OrderController@listorderfinish')->name('Order.list2');
        Route::get('detail-order/{id}', 'OrderController@detailOrder')->name('detail.Order');
	});
    Route::group(['prefix' => 'ads'], function(){
        Route::get('add', 'AdsController@addAds')->name('ads.add');
        Route::post('dt-add','AdsController@dtAddAds')->name('dt.ads.add');

        Route::get('edit/{id}', 'AdsController@editAds')->name('ads.edit');
        Route::post('update/{id}', 'AdsController@updateAds')->name('ads.update');

        Route::get('delete/{id}', 'AdsController@deleteAds')->name('ads.delete');

        Route::get('dt-list', 'AdsController@dtListAds')->name('dt.ads.list');
        Route::get('list', 'AdsController@listAds')->name('ads.list');
        //show
    });

    // vendor
    Route::group(['prefix' => 'vendor'], function(){
        Route::get('list-vendor', 'CustomerController@showListVendor')->name('list.vendor');
        Route::get('dt-vendor', 'CustomerController@dataTableVendor')->name('dt.vendor');
        Route::get('detail-vendor/{vendorId}', 'CustomerController@showDetailVendor')->name('detail.vendor');
        Route::get('confirm-vendor/', 'CustomerController@confirmVendor')->name('confirm.vendor');
        Route::get('delete-vendor/{id}', 'CustomerController@deleteVendor')->name('delete.vendor');
    });
    //Contact
    Route::get('contact','ContactController@index')->name('contact.list');
    Route::get('contact/{action}/{id}','ContactController@action')->name('contact.action');
    Route::post('contact/reply-contact/{id}','ContactController@replyContact');
    Route::get('contact/send-mail/{email}/{title}/{content}','ContactController@sendMailReplyContact')->name('send.mail.contact');


    // Customer

app/Http/Controllers/Site/ProductController.php
<?php

namespace App\Http\Controllers\Site;

use App\Entity\Attribute;
use App\Entity\Product;
use App\Entity\Comment;
use App\Entity\Image;
use App\Entity\Category;
use App\Entity\Ads;

use App\Entity\Rate;
use App\Entity\SubProduct;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Carbon\Carbon;
use Illuminate\Support\Facades\Auth;

class ProductController extends Controller
{
    //

    public function detailProduct(Request $request){


        $infoProduct = Product::where('id',$request->id)->firstOrFail();

        //Get Category and Images
        $category = Category::where('id', $infoProduct->category_id)->first();
        $images = Image::where('product_id', $request->id)->get();

        //Get New Status
        $now = Carbon::now();
        $date = $infoProduct->created_at;
        $diffDate = $now->diffInDays($date);

        if($diffDate < 3){
            $status = 'new';
        }else{
            $status = null;
        }

        if($infoProduct->type == 0){
            $product = Product::where('id',$request->id)->firstOrFail();
            $options = null;
        }else{
            $product = SubProduct::where('product_id', $request->id)->where('quantity','>' ,0)->first();
            $options = SubProduct::where('product_id', $request->id)->where('quantity','>' ,0)->get();
        }

        // Hiển thị rating với user_id và 1 product_id tương ứng.
        $rates = Rate::where('product_id',$product->id)->where('user_id',Auth::id());
        // Tính rating star trung bình user_id và 1 product_id tương ứng
        $sum_rate = round((Rate::where('product_id',$product->id)->avg('point_star')));
        // sản phẩm liên quan lấy theo category id
        $rale_products = Product::where('category_id',$product->category_id)->get();
        //  tăng view khi click vào chi tiết sản phẩm
//        Product::where('id',$infoProduct->id)->update([
//                "view"=>$infoProduct->view+1
//            ]);

        //image
        $productImages = Image::where('status','1')->get();
        //đếm số lượt review
        $review = count(Comment::where('product_id',$product->id)->get('content'));

        $reviews = Comment::get();

        $rating = Rate::get();

        $ads = Ads::where('status','1')->limit(2)->get();
//        Share link facebook
        $url_canonical =$request->url();
        
        return view('site.product.detail',[
            'info'		        => $infoProduct,
            'product'	        => $product,
            'options' 	        => $options,
            'images'	        => $images,
            'category'	        => $category,
            'status'	        => $status,
            'rates'             => $rates,
            'sum_rate'          => $sum_rate,
            'rale_products'     => $rale_products,
            'productImages'     => $productImages,
            'review'            => $review,
            'rating'            => $rating,
            'reviews'           => $reviews,
            'url_canonical'     => $url_canonical,
            'ads'               => $ads
        ]);
    }
	public function showOptionAttribute($id, $option_id){
		$attributes = SubProduct::where('product_id', $id)->where('id', $option_id)->first();
		return json_encode($attributes);
	}


}

resources/views/admin/product/tab/add.blade.php
    <!-- Container Fluid-->

        {{--{{dd(\App\Entity\Category::getSubCategory($categories,0))}}--}}
{{--        <form method="post" action="{{route('product.store')}}" enctype="multipart/form-data">--}}
{{--            {{csrf_field()}}--}}
        <form method="post" action="{{route('product.tab.add')}}" enctype="multipart/form-data" id="add-product">
                @csrf
            <div class="row">
                <div class="col-lg-12">
                    <!-- Form Basic -->
                    <div class="card mb-4">
                        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                            <h6 class="m-0 font-weight-bold text-primary">Nhập thông tin</h6>
                        </div>
                        <div class="card-body">
                            <div class="form-group">
                                <label for="exampleInputEmail1">Tên sản phẩm</label>
                                <input type="text" class="form-control" name="name" id="exampleInputEmail1" aria-describedby="emailHelp" placeholder="" value="{{old('name')}}">
                            </div>

                        </div>
                    </div>
                    <div class="card mb-4">
                        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                            <h6 class="m-0 font-weight-bold text-primary">Chọn danh mục </h6>
                        </div>
                        <div class="card-body">
                            <div class="form-group">

                                <input class="easyui-combotree" id="cate-tree" style="width:100%">
                                <input type="hidden" name="category_id" >

                            </div>
                            <div class="form-group line-category">

                            </div>
                        </div>
                    </div>

                    <div class="card mb-4">
                        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                            <h6 class="m-0 font-weight-bold text-primary">Thêm thông tin</h6>
                        </div>

                        <div class="card-body">
                            <div class="form-group">
                                <label>Mô tả ngắn</label>
                                <textarea name="short_description" class="form-control editor"> {{old('short_description')}}</textarea>
                            </div>
                        </div>

                        <div class="card-body">
                            <div class="form-group">
                                <label>Mô tả</label>
                                <textarea name="description" class="form-control editor" id="editor1">{{old('description')}}</textarea>
                            </div>
                        </div>
                    </div>
                    <div class="card mb-4">
                        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                            <h6 class="m-0 font-weight-bold text-primary">Chọn Ảnh Sản phẩm</h6>
                        </div>
                        <div class="card-body">
                            <div class="form-group">
                                <label for="exampleInputFile">Ảnh SP</label>
                                <div class="input-group" style="">
                                    <div class="custom-file">
                                        <input type="file" class="custom-file-input" id="pick-images" name="image">
                                        <input type="hidden" name="image_avatar" id="image-avatar">
                                        <label class="custom-file-label" for="exampleInputFile">Choose file</label>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group image-list">

                            </div>
                            <style>
                                .image-pic {
                                    position: relative;
                                    display: inline-block;
                                }
                                .image-pic:hover .remove {
                                    display: block;
                                }

                                .remove {
                                    padding-right: 7px;
                                    position: absolute;
                                    right: 0;
                                    top: 0;
                                    display: none;
                                }
                            </style>
                            <div class="image-pics">

                            </div>
                        </div>
                    </div>
                </div>


            </div>
        </form>
        <!--Row-->

        <!-- Documentation Link -->



    <!---Container Fluid-->

resources/views/admin/product/tab/add_sub_product.blade.php
<form method="post" action="{{route('product.tab.addSubProduct')}}" enctype="multipart/form-data" id="add-subproduct">
    @csrf
<div class="row">
    <div class="col-lg-12">
        <!-- Form Basic -->
        <div class="card mb-4">
            <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                <h6 class="m-0 font-weight-bold text-primary">Nhập thông tin</h6>
            </div>
            <div class="card-body">

                <div class="form-group">
                    <label for="exampleInputEmail1">Tên sản phẩm</label>
                    <input type="text" class="form-control" name="name" id="name_parent_product" aria-describedby="emailHelp" placeholder="" value="{{old('name')}}" readonly>
                </div>

                <div class="form-group">
                    <select class="form-control select-attribute" id="exampleFormControlSelect1">
                        <option selected>--------- Chọn thuộc tính ---------</option>
                        @foreach($attributes as $att)
                                <option value="{{$att->id}}">{{$att->name}}</option>
                        @endforeach
                    </select>
                </div>
                <button type="button" class="btn btn-primary mb-1" id="choose-att" onclick="return getAttribute(this);">
                    Thêm
                </button>

                <div class="add-attribute">

                </div>
                <div class="form-group">
                    <label for="exampleInputEmail1">Số lượng</label>
                    <input type="text" class="form-control formatPrice" id="soluong" placeholder="nhập tên danh mục" name="quantity_sub" required="">
                </div>

                <div class="form-group">
                    <label for="exampleInputEmail1">Đơn giá</label>
                    <input type="text" class="form-control formatPrice" name="price_sub" placeholder="Giá khuyến mãi" min="1" id="dongia" required="">

                </div>

                <div class="form-group">
                    <label for="exampleInputEmail1">Giá khuyến mãi</label>
                    <input type="text" class="form-control formatPrice" name="discount_sub" placeholder="Giá khuyến mãi" min="1" id="khuyenmai" required="">

                </div>

            </div>
            <button type="button" class="btn btn-primary mb-1" id="add-to-subproduct" onclick="return addSubProduct(this);">
                quick create
            </button>
        </div>
    </div>
</div>
</form>
@push('scripts')
    <script type="text/javascript">
        function addSubProduct() {
            var soluong = document.getElementById("soluong").value;;
            var dongia = document.getElementById("dongia").value;;
            var khuyenmai = document.getElementById("khuyenmai").value;;
            if(soluong == ""){alert("Vui lòng nhập số lượng sản phẩm");}
            // check đơn giá
            if(dongia == ""){alert("Vui lòng nhập giá cho sản phẩm");}
            //check khuyến mãi
            if(khuyenmai == 0){alert("Vui lòng nhập giá khuyến mãi nếu không thì hãy nhập là 0");}
        }
    </script>
@endpush

resources/views/admin/product/tab/add_thumbimage.blade.php
        <div class="container">
            <div class="row">
                    <div class="col-md-1">

                    </div>
                <div class="col-md-10">
                    <input type="hidden" name="_token" value="{{csrf_token()}}">
                    <div class="form-group">
                        <input id="input-705" name="file" type="file" accept="image/*" multiple>
                    </div>
                </div>

                <div class="col-md-1">

                </div>




            </div>
        </div>



@push('scripts')

    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/5.0.1/js/plugins/piexif.min.js" type="text/javascript"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/5.0.1/js/plugins/sortable.min.js" type="text/javascript"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/5.0.1/js/plugins/purify.min.js" type="text/javascript"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.11.0/umd/popper.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/4.4.7/js/fileinput.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-fileinput/4.4.7/themes/fa/theme.js"></script>


    <script>
            $(document).ready(function() {
                var $el1 = $("#input-705");
                $el1.fileinput({
                    theme: 'fa',
                    allowedFileExtensions: ['jpg', 'png', 'gif'],
                    uploadUrl: "/admin/add-images-product",
                    uploadExtraData:function(){
                        return{
                            _token:$("input[name='_token']").val()
                        };
                    },
                    uploadAsync: true,
                    // deleteUrl: "/site/file-delete",
                    // showUpload: false, // hide upload button
                    // showRemove: false, // hide remove button
                    overwriteInitial: false, // append files to initial preview
                    minFileCount: 1,
                    maxFileCount: 5,
                    // initialPreviewAsData: true,
                });
            });
        </script>

@endpush